var EntryList;
var EntryDesc;
var cqrShowBlocked = false;

function init(){
  EntryList    = document.getElementById('EntryList');
  EntryDesc    = document.getElementById('Desc');
  cqrShowBlocked  = document.getElementById('showblocked').checked;
  
  ////moved to main.js
  //prfs_LoadMain();
  
	plg_QuickLoadAll();
  prfs_UpdateEntries();

	window.setTimeout('initWithDelay();', 0);
  //window.sizeToContent();
}

function initWithDelay(){
  fillprefstab();
  initList(EntryList, EntryHash);
}

function plg_ReloadTree(){
	plg_QuickLoadAll();
  prfs_UpdateEntries();
  initList(EntryList, EntryHash);
}

function plg_block(really){
  if (!EntryList.selectedItem) return;
  EntryHash[EntryList.selectedItem.getAttribute('value')].blocked = really;
  prfs_SaveEntries();
  plg_ReloadTree();
}

function fillprefstab() {
	document.getElementById('prfs_plugsdir').value = cqrPlugsDir;
	document.getElementById('enhotmenu').checked = cqrUseHotMenu;
	document.getElementById('HTTPIcon').checked = cqrHTTPIcon;
	switch (cqrOpenRes)
	{
		case 'tab_bg':
		    document.getElementById('open_res').selectedIndex = 0;
		    break;
		case 'tab_fg':
		    document.getElementById('open_res').selectedIndex = 1;
		    break;
		case 'win_bg':
		    document.getElementById('open_res').selectedIndex = 2;
		    break;
		case 'win_fg':
		    document.getElementById('open_res').selectedIndex = 3;
		    break;
	}
}



function initList(list, srcHash){
  cqrShowBlocked  = document.getElementById('showblocked').checked;
  while (list.hasChildNodes()) {list.removeChild(list.lastChild)}
  var ondk;
  var onsel;
  var item;
  var node;
  var celldata;
  var cellcheck;
  var entries = srcHash._Items();

  var listcols =  document.createElement('listcols');
  var listcol1 =  document.createElement('listcol');
  var listcol2 =  document.createElement('listcol');
  var listcol3 =  document.createElement('listcol');
  var splitter = document.createElement('splitter');
  var listhead = document.createElement('listhead');
  var listheader1 =  document.createElement('listheader');
  var listheader2 =  document.createElement('listheader');
  var listheader3 =  document.createElement('listheader');
  splitter.setAttribute("class", "tree-splitter");
  listcol1.setAttribute("flex", "16");
  listcol2.setAttribute("flex", "1");
  listcol2.setAttribute("style", "width: 4em;");
  listcol3.setAttribute("flex", "1");
  listcol3.setAttribute("style", "width: 5em;");
  listcols.appendChild(listcol1);
    if (srcHash == EntryHash){
      listcols.appendChild(splitter);
      listcols.appendChild(listcol2);
      listcols.appendChild(listcol3);
    }
  listheader1.setAttribute('label', cqrMess.GetStringFromName('cqr.cfg.plgCol'));
  listheader2.setAttribute('label', cqrMess.GetStringFromName('cqr.cfg.showCol'));
  listheader3.setAttribute('label', cqrMess.GetStringFromName('cqr.cfg.showIfCol'));
  listhead.appendChild(listheader1);
    if (srcHash == EntryHash){
      listhead.appendChild(listheader2);
      listhead.appendChild(listheader3);
    }
  list.appendChild(listcols);
  list.appendChild(listhead);
  
  for (i=0; i<entries.length; i++){
		if ((!cqrShowBlocked) && (entries[i].blocked)) continue;
	ondk  = 'if (isValidLeftClick(event,"listitem")) ExecQuery(event.ctrlKey, "'+entries[i].eId+'");';
	onsel = 'onSelect(EntryHash, EntryDesc, '+entries[i].eId+')'

    item = document.createElement('listitem');
    item.setAttribute('value', entries[i].eId);
    item.setAttribute('allowevents', true);
    //if (entries[i].showif) item.setAttribute('style', "color: #408080");
    if (entries[i].blocked) item.setAttribute('style', "color: #828282");
		//item.setAttribute('ondblclick', ondk);
		
    celldata = document.createElement('listcell');
    celldata.setAttribute('label', entries[i].Title);
    celldata.setAttribute('ondblclick', ondk);
    item.appendChild(celldata);
    if (srcHash == EntryHash){
      cellcheck = document.createElement('listcell');
      check = document.createElement('checkbox');
      check.setAttribute('id', entries[i].eId);
      check.setAttribute('oncommand', "UpdateStatus(this);");
      check.setAttribute('checked', entries[i].Context);
      cellcheck.appendChild(check);
      item.appendChild(cellcheck);
      if (entries[i].showif){
        cellshowif = document.createElement('listcell');
        cellshowif.setAttribute('label', "yes");
        item.appendChild(cellshowif);
      }
    }
    list.appendChild(item);
  }
}

function onSelect(){
	var desctext = "";
	eId = EntryList.selectedItem.getAttribute('value');
	item = EntryHash._Item(eId);
	if (!item.Inputs){
		item = plg_ReadData(item.filepath);
    item.Context = EntryHash[eId].Context;
    item.lastmatch = EntryHash[eId].lastmatch;
		EntryHash._AddEntryObj(item);
	}
	
	desctext = item.Title + ":\n" +
  	item.Desc + "\n" +
  	item.filepath;
	if (item.showif) desctext += cqrMess.GetStringFromName('cqr.cfg.descrSI') + item.showif + " " + cqrMess.GetStringFromName('cqr.cfg.descrSIfound') + item.sitarget;
	desctext += cqrMess.GetStringFromName('cqr.cfg.descrInps') + "Action = " + item.Action + "\n";
  for (i in item.Inputs){
    desctext += i+" = "+item.Inputs[i].value +"\n";
    if (item.Inputs[i].list){
    	for (v in item.Inputs[i].list) desctext += " " + cqrMess.GetStringFromName('cqr.cfg.descrInpsOr') + " " + item.Inputs[i].list[v].value + "\n";
    }
  }
	EntryDesc.value = desctext;
}

function UpdateStatus(check){
  EntryHash[check.id].Context = check.checked;
	prfs_SaveEntries();
}

function ExecQuery(ctrl, id){
try{
  window.opener.top.cqrConfigLastWillId = EntryList.selectedItem.getAttribute('value');
  window.opener.top.cqrConfigLastWillCtrl = ctrl;
  window.close();
}catch(er){cqerr(er, "ExecQuery sub")}
}


function isValidLeftClick(aEvent, aName){
  return (aEvent.button == 0 && aEvent.originalTarget.localName == aName);
}

